private {
	import string;
	import stream;
	import console;
	import seudodig;
}

alias string.toupper toupper;

int main(char[][] args) {
	{
		int f,g;
		Console.getcolor(f,g);
		if (f<8) Console.color(f+8);
		Console.io.write('vb2d');
		if (f>8) Console.color(f-8);
		else Console.color(f);
		Console.io.writeLine(': traductor de formularios de VisualBasic 6 a DMD+DIG');
		if (f>8) Console.color(f);
		Console.io.writeLine('Por Carlos Santander B.');
	}
	
	char[] nomArchivo;
	int s=1;
	bit conMain=true;
	
	if (args.length>1)
		if (args[1][0]=='-') {
			s=2;
			if (icmp(args[1],'-nomain')==0) conMain=false;
		}
		
	if (args.length>s)
		nomArchivo=args[s];
	else {
		Console.io.write('Ingrese el nombre del archivo (.frm): ');
		nomArchivo=Console.io.readLine();
	}
	
	if (nomArchivo.length>0) {
		{
			int r=rfind(toupper(nomArchivo),'.FRM');
			if (r!=-1) nomArchivo = nomArchivo[0..r];
		}
		
		File vb,dig;
		
		try vb=new File(nomArchivo~'.frm',FileMode.In);
		catch (Error) {
			Console.io.writeLine('Error al abrir: '~nomArchivo~'.frm');
			return -1;
		}
		
		dig=new File();
		try dig.create(nomArchivo~'.d');
		catch (Error) {
			Console.io.writeLine('Error al abrir: '~nomArchivo~'.d');
			return -1;
		}
		
		Frame fra=new Frame();
		uint enHijo=0,_left,_top,_p_left,_p_top;
		bit
			enFont=false,
			enFrame=false,
			enButton=false,
			enGroupBox=false,
			enListBox=false,
			enCheckBox=false,
			enComboBox=false,
			enEditText=false,
			enLabel=false,
			enRadioButton=false;
		Button but;
		GroupBox gb,gb2,gb3;
		ListBox lb;
		CheckBox cb;
		ComboBox cbo;
		EditText edt;
		Label lbl;
		RadioButton rad;
		
		do {
			char[] buf=strip(vb.readLine());/**Console.io.writeLine(buf);/**/
			if (buf.length==0) break;
			if (icmp(buf[0..3],'end')==0 && buf.length==3) {
				if (enHijo>0) {
					enHijo--;
					if (enHijo==0) {
						_left=0;
						_top=0;
					} else if (enHijo==1) {
						_left=_p_left;
						_top=_p_top;
						_p_left=0;
						_p_top=0;
					}
					if (enButton) {
						but=null;
						enButton=false;
					} else if (enListBox) {
						lb=null;
						enListBox=false;
					} else if (enCheckBox) {
						cb=null;
						enCheckBox=false;
					} else if (enComboBox) {
						cbo=null;
						enComboBox=false;
					} else if (enEditText) {
						edt=null;
						enEditText=false;
					} else if (enLabel) {
						lbl=null;
						enLabel=false;
					} else if (enRadioButton) {
						rad=null;
						enRadioButton=false;
					} else if (enGroupBox) {
						if (gb2===null) {
							gb=null;
							enGroupBox=false;
						} else {
							gb=gb2;
							gb2=gb3;
							if (gb3!==null)
								gb3=null;
						}
					}
				} else if (enFrame) {
					enFrame=false;
					break;
				}
			} else if (icmp(buf[0..4],'text')==0) {
				if (enHijo>0) {
					int q1=string.find(buf,cast(char)'"'),q2=string.rfind(buf,cast(char)'"');
					char[] txt=buf[q1+1..q2];
					if (enEditText)
						edt.text=txt;
					else if (enComboBox)
						cbo.text=txt;
				}
			} else if (icmp(buf[0..4],'name')==0) {
				if (enFont) {
					int
						q1=string.find(buf,cast(char)'"'),
						q2=string.rfind(buf,cast(char)'"');
					char[] fontname=buf[q1+1..q2];
					if (enHijo>0) {
						if (enButton)
							but.fontName=fontname;
						else if (enCheckBox)
							cb.fontName=fontname;
						else if (enListBox)
							lb.fontName=fontname;
						else if (enComboBox)
							cbo.fontName=fontname;
						else if (enEditText)
							edt.fontName=fontname;
						else if (enLabel)
							lbl.fontName=fontname;
						else if (enRadioButton)
							rad.fontName=fontname;
						else if (enGroupBox)
							gb.fontName=fontname;
					} else
						if (enFrame)
							fra.fontName=fontname;
				}
			} else if (icmp(buf[0..4],'size')==0) {
				if (enFont) {
					int q=string.rfind(buf,cast(char)' ');
					int h=atoi(buf[q+1..buf.length]);
					if (enHijo>0) {
						if (enButton)
							but.fontSize=h;
						else if (enCheckBox)
							cb.fontSize=h;
						else if (enListBox)
							lb.fontSize=h;
						else if (enComboBox)
							cbo.fontSize=h;
						else if (enEditText)
							edt.fontSize=h;
						else if (enLabel)
							lbl.fontSize=h;
						else if (enRadioButton)
							rad.fontSize=h;
						else if (enGroupBox)
							gb.fontSize=h;
					} else
						if (enFrame)
							fra.fontSize=h;
				}
			} else if (icmp(buf[0..4],'top ')==0) {
				if (enHijo>0) {
					int q=string.rfind(buf,cast(char)' ');
					int h=atoi(buf[q+1..buf.length]);
					if (enButton)
						but.top=h+_top+_p_top;
					else if (enCheckBox)
						cb.top=h+_top+_p_top;
					else if (enListBox)
						lb.top=h+_top+_p_top;
					else if (enComboBox)
						cbo.top=h+_top+_p_top;
					else if (enEditText)
						edt.top=h+_top+_p_top;
					else if (enLabel)
						lbl.top=h+_top+_p_top;
					else if (enRadioButton)
						rad.top=h+_top+_p_top;
					else if (enGroupBox)
						gb.top=h+_top+_p_top;
					else {
						if (_top==0)
							_top=h;
						else {
							_p_top=_top;
							_top=h;
						}
					}
				}
			} else if (icmp(buf[0..5],'left ')==0) {
				if (enHijo>0) {
					int q=string.rfind(buf,cast(char)' ');
					int h=atoi(buf[q+1..buf.length]);
					if (enButton)
						but.left=h+_left+_p_left;
					else if (enCheckBox)
						cb.left=h+_left+_p_left;
					else if (enListBox)
						lb.left=h+_left+_p_left;
					else if (enComboBox)
						cbo.left=h+_left+_p_left;
					else if (enEditText)
						edt.left=h+_left+_p_left;
					else if (enLabel)
						lbl.left=h+_left+_p_left;
					else if (enRadioButton)
						rad.left=h+_left+_p_left;
					else if (enGroupBox)
						gb.left=h+_left+_p_left;
					else {
						if (_left==0)
							_left=h;
						else {
							_p_left=_left;
							_left=h;
						}
					}
				}
			} else if (icmp(buf[0..5],'index')==0) {
				if (enHijo>0) {
					int q=string.find(buf,cast(char)'=');
					char[] i='_'~strip(buf[q+1..buf.length]);
					if (enButton)
						but.name~=i;
					else if (enCheckBox)
						cb.name~=i;
					else if (enListBox)
						lb.name~=i;
					else if (enComboBox)
						cbo.name~=i;
					else if (enEditText)
						edt.name~=i;
					else if (enLabel)
						lbl.name~=i;
					else if (enRadioButton)
						rad.name~=i;
					else if (enGroupBox)
						gb.name~=i;
				}
			} else if (icmp(buf[0..6],'weight')==0) {
				if (enFont) {
					int q=string.rfind(buf,cast(char)' ');
					bit h=atoi(buf[q+1..buf.length])==700;
					if (enHijo>0) {
						if (enButton)
							but.fontBold=h;
						else if (enCheckBox)
							cb.fontBold=h;
						else if (enListBox)
							lb.fontBold=h;
						else if (enComboBox)
							cbo.fontBold=h;
						else if (enEditText)
							edt.fontBold=h;
						else if (enLabel)
							lbl.fontBold=h;
						else if (enRadioButton)
							rad.fontBold=h;
						else if (enGroupBox)
							gb.fontBold=h;
					} else
						if (enFrame)
							fra.fontBold=h;
				}
			} else if (icmp(buf[0..6],'italic')==0) {
				if (enFont) {
					int q=string.rfind(buf,cast(char)'0');
					bit h= q==-1;
					if (enHijo>0) {
						if (enButton)
							but.fontItalic=h;
						else if (enCheckBox)
							cb.fontItalic=h;
						else if (enListBox)
							lb.fontItalic=h;
						else if (enComboBox)
							cbo.fontItalic=h;
						else if (enEditText)
							edt.fontItalic=h;
						else if (enLabel)
							lbl.fontItalic=h;
						else if (enRadioButton)
							rad.fontItalic=h;
						else if (enGroupBox)
							gb.fontItalic=h;
					} else
						if (enFrame)
							fra.fontItalic=h;
				}
			} else if (icmp(buf[0..6],'begin ')==0) {
				bit enFrameF=false;
				if (icmp(buf[6..13],'vb.form')==0) {
					fra.name=buf[14..buf.length];
					enFrame=true;
					enFrameF=true;
				} else if (icmp(buf[6..13],'vb.line')==0) { //ignorar?
				} else if (icmp(buf[6..13],'vb.menu')==0) {
				} else if (icmp(buf[6..14],'vb.shape')==0) { //ignorar?
				} else if (icmp(buf[6..14],'vb.image')==0) { //ignorar?
					if (enGroupBox) {
						if (gb2!==null)
							gb3=gb2;
						gb2=gb;
					} else {
						gb2=null;
						gb3=null;
					}
					gb=new GroupBox();
					if (gb2===null) gb.parent(fra); else gb.parent(gb2);
					gb.name=buf[15..buf.length];
					enGroupBox=true;
				} else if (icmp(buf[6..14],'vb.frame')==0) {
					if (enGroupBox) {
						if (gb2!==null)
							gb3=gb2;
						gb2=gb;
					} else {
						gb2=null;
						gb3=null;
					}
					gb=new GroupBox();
					if (gb2===null) gb.parent(fra); else gb.parent(gb2);
					gb.name=buf[15..buf.length];
					enGroupBox=true;
				} else if (icmp(buf[6..14],'vb.label')==0) {
					lbl=new Label();
					if (enGroupBox) lbl.parent(gb); else lbl.parent(fra);
					lbl.name=buf[15..buf.length];
					enLabel=true;
				} else if (icmp(buf[6..16],'vb.mdiform')==0) {
					fra.name=buf[17..buf.length];
					enFrame=true;
					enFrameF=true;
				} else if (icmp(buf[6..16],'vb.textbox')==0) {
					edt=new EditText();
					if (enGroupBox) edt.parent(gb); else edt.parent(fra);
					edt.name=buf[17..buf.length];
					enEditText=true;
				} else if (icmp(buf[6..16],'vb.listbox')==0) {
					lb=new ListBox();
					if (enGroupBox) lb.parent(gb); else lb.parent(fra);
					lb.name=buf[17..buf.length];
					enListBox=true;
				} else if (icmp(buf[6..17],'vb.combobox')==0) {
					cbo=new ComboBox();
					if (enGroupBox) cbo.parent(gb); else cbo.parent(fra);
					cbo.name=buf[18..buf.length];
					enComboBox=true;
				} else if (icmp(buf[6..17],'vb.checkbox')==0) {
					cb=new CheckBox();
					if (enGroupBox) cb.parent(gb); else cb.parent(fra);
					cb.name=buf[18..buf.length];
					enCheckBox=true;
				} else if (icmp(buf[6..18],'tabdlg.sstab')==0) { //ignorar?
				} else if (icmp(buf[6..19],'vb.picturebox')==0) { //pane?
					if (enGroupBox) {
						if (gb2!==null)
							gb3=gb2;
						gb2=gb;
					} else {
						gb2=null;
						gb3=null;
					}
					gb=new GroupBox();
					if (gb2===null) gb.parent(fra); else gb.parent(gb2);
					gb.name=buf[20..buf.length];
					enGroupBox=true;
				} else if (icmp(buf[6..19],'vb.dirlistbox')==0) {
					lb=new ListBox();
					if (enGroupBox) lb.parent(gb); else lb.parent(fra);
					lb.name=buf[20..buf.length];
					enListBox=true;
				} else if (icmp(buf[6..21],'vb.drivelistbox')==0) {
					cbo=new ComboBox();
					if (enGroupBox) cbo.parent(gb); else cbo.parent(fra);
					cbo.name=buf[22..buf.length];
					enComboBox=true;
				} else if (icmp(buf[6..21],'vb.optionbutton')==0) {
					rad=new RadioButton();
					if (enGroupBox) rad.parent(gb); else rad.parent(fra);
					rad.name=buf[22..buf.length];
					enRadioButton=true;
				} else if (icmp(buf[6..22],'vb.commandbutton')==0) {
					but=new Button();
					if (enGroupBox) but.parent(gb); else but.parent(fra);
					but.name=buf[23..buf.length];
					enButton=true;
				} else if (icmp(buf[6..24],'mscomctl2.dtpicker')==0) {
					cbo=new ComboBox();
					if (enGroupBox) cbo.parent(gb); else cbo.parent(fra);
					cbo.name=buf[25..buf.length];
					enComboBox=true;
				}
				if (!enFrameF) enHijo++;
			} else if (icmp(buf[0..6],'width ')==0) {
				if (enHijo>0) {
					int q=string.rfind(buf,cast(char)' ');
					int h=atoi(buf[q+1..buf.length]);
					if (enButton)
						but.width=h;
					else if (enCheckBox)
						cb.width=h;
					else if (enListBox)
						lb.width=h;
					else if (enComboBox)
						cbo.width=h;
					else if (enEditText)
						edt.width=h;
					else if (enLabel)
						lbl.width=h;
					else if (enRadioButton)
						rad.width=h;
					else if (enGroupBox)
						gb.width=h;
				}
			} else if (icmp(buf[0..7],'height ')==0) {
				if (enHijo>0) {
					int q=string.rfind(buf,cast(char)' ');
					int h=atoi(buf[q+1..buf.length]);
					if (enButton)
						but.height=h;
					else if (enCheckBox)
						cb.height=h;
					else if (enListBox)
						lb.height=h;
					else if (enComboBox)
						cbo.height=h;
					else if (enEditText)
						edt.height=h;
					else if (enLabel)
						lbl.height=h;
					else if (enRadioButton)
						rad.height=h;
					else if (enGroupBox)
						gb.height=h;
				}
			} else if (icmp(buf[0..7],'caption')==0) {
				int
					q1=string.find(buf,cast(char)'"'),
					q2=string.rfind(buf,cast(char)'"');
				char[] cap=buf[q1+1..q2];
				if (enHijo==0)
					fra.caption=cap;
				else if (enButton)
					but.caption=cap;
				else if (enLabel)
					lbl.caption=cap;
				else if (enCheckBox)
					cb.caption=cap;
				else if (enRadioButton)
					rad.caption=cap;
				else if (enGroupBox)
					gb.caption=cap;
			} else if (icmp(buf[0..7],'version')==0) { //ignorar
			} else if (icmp(buf[0..7],'default')==0) {
				if (enButton) {
					int q=string.find(buf,cast(char)'=');
					int d=atoi(buf[q+1..buf.length]);
					but.bordered=d!=0;
				}
			} else if (icmp(buf[0..9],'underline')==0) {
				if (enFont) {
					int q=string.rfind(buf,cast(char)'0');
					bit h= q==-1;
					if (enHijo>0) {
						if (enButton)
							but.fontUnderline=h;
						else if (enCheckBox)
							cb.fontUnderline=h;
						else if (enListBox)
							lb.fontUnderline=h;
						else if (enComboBox)
							cbo.fontUnderline=h;
						else if (enEditText)
							edt.fontUnderline=h;
						else if (enLabel)
							lbl.fontUnderline=h;
						else if (enRadioButton)
							rad.fontUnderline=h;
						else if (enGroupBox)
							gb.fontUnderline=h;
					} else
						if (enFrame)
							fra.fontUnderline=h;
				}
			} else if (icmp(buf[0..9],'alignment')==0) {
				if (enHijo>0) {
					int q=string.find(buf,cast(char)'=');
					int a=atoi(buf[q+1..buf.length]);
					if (enLabel) {
						lbl.alignLeft=a==0;
						lbl.alignRight=a==1;
					}/* else if (enEditText) {
						edt.alignLeft=a==0;
						edt.alignRigth=a==1;
					}*/
				}
			} else if (icmp(buf[0..9],'scalemode')==0) {
				if (enHijo>0) { }
				else if (enFrame) {
					int q=string.find(buf,cast(char)'=');
					fra.scalemode=atoi(buf[q+1..buf.length]);
				}
			} else if (icmp(buf[0..9],'maxbutton')==0) {
				if (enHijo>0) { }
				else if (enFrame) {
					int q=string.find(buf,cast(char)'0');
					fra.maxbox = q==-1;
				}
			} else if (icmp(buf[0..9],'minbutton')==0) {
				if (enHijo>0) { }
				else if (enFrame) {
					int q=string.find(buf,cast(char)'0');
					fra.minbox = q==-1;
				}
			} else if (icmp(buf[0..9],'clienttop')==0) {
				if (enHijo>0) { }
				else if (enFrame) {
					int q=string.rfind(buf,cast(char)' ');
					fra.top=atoi(buf[q+1..buf.length]);
				}
			} else if (icmp(buf[0..10],'scrollbars')==0) {
				int q=string.find(buf,cast(char)'=');
				int sb=atoi(buf[q+1..buf.length]);
				if (enEditText) {
					edt.hscroll=(sb%2==1);
					edt.vscroll=(sb>1);
				} else if (enListBox) {
					lb.hscroll=(sb%2==1);
					lb.vscroll=(sb>1);
				}
			} else if (icmp(buf[0..10],'clientleft')==0) {
				if (enHijo>0) { }
				else if (enFrame) {
					int q=string.rfind(buf,cast(char)' ');
					fra.left=atoi(buf[q+1..buf.length]);
				}
			} else if (icmp(buf[0..10],'controlbox')==0) {
				if (enHijo>0) { }
				else if (enFrame) {
					int q=string.find(buf,cast(char)'0');
					fra.controlbox = q==-1;
				}
			} else if (icmp(buf[0..11],'endproperty')==0) {
				if (enFont) enFont=false;
			} else if (icmp(buf[0..11],'clientwidth')==0) {
				if (enHijo>0) { }
				else if (enFrame) {
					int q=string.rfind(buf,cast(char)' ');
					fra.width=atoi(buf[q+1..buf.length]);
				}
			} else if (icmp(buf[0..11],'borderstyle')==0) {
				if (enHijo>0) { }
				else if (enFrame) {
					int q=string.find(buf,cast(char)'=');
					int b=atoi(buf[q+1..buf.length]);
					with (fra)
						switch (b) {
							case 0: //none
								captionbar=false;
								break;
							case 1: //fixed single
							case 3: //fixed dialog
							case 4: //fixed toolwindow
								resize=false;
								break;
							case 5: //sizable toolwindow
							default: //2:sizable
								resize=true;
						}
				}
			} else if (icmp(buf[0..12],'clientheight')==0) {
				if (enHijo>0) { }
				else if (enFrame) {
					int q=string.rfind(buf,cast(char)' ');
					fra.height=atoi(buf[q+1..buf.length]);
				}
			} else if (icmp(buf[0..13],'strikethrough')==0) {
				if (enFont) {
					int q=string.rfind(buf,cast(char)'0');
					bit h= q==-1;
					if (enHijo>0) {
						if (enButton)
							but.fontStrikeout=h;
						else if (enCheckBox)
							cb.fontStrikeout=h;
						else if (enListBox)
							lb.fontStrikeout=h;
						else if (enComboBox)
							cbo.fontStrikeout=h;
						else if (enEditText)
							edt.fontStrikeout=h;
						else if (enLabel)
							lbl.fontStrikeout=h;
						else if (enRadioButton)
							rad.fontStrikeout=h;
						else if (enGroupBox)
							gb.fontStrikeout=h;
					} else
						if (enFrame)
							fra.fontStrikeout=h;
				}
			} else if (icmp(buf[0..13],'beginproperty')==0) {
				if (icmp(buf[14..18],'font')==0) {
					enFont=true;
					if (enHijo>0) {
						if (enButton)
							but.fontSet=true;
						else if (enCheckBox)
							cb.fontSet=true;
						else if (enListBox)
							lb.fontSet=true;
						else if (enComboBox)
							cbo.fontSet=true;
						else if (enEditText)
							edt.fontSet=true;
						else if (enLabel)
							lbl.fontSet=true;
						else if (enRadioButton)
							rad.fontSet=true;
						else if (enGroupBox)
							gb.fontSet=true;
					} else
						if (enFrame)
							fra.fontSet=true;
				}
			}
		} while (1)
		
		//guardar(fra,Console.io,conMain);
		guardar(fra,dig,conMain);
				
		vb.close();
		dig.close();
		
		return 0;
	}
	
	return -1;
}